Subject: Re: [PATCH bpf-next] selftests, bpf: remove AF_XDP samples

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Fri, 01 Jul 2022 14:15:37 +0200

Magnus Karlsson <[email-masked]> writes:

> On Thu, Jun 30, 2022 at 3:44 PM Jesper Dangaard Brouer
> <[email-masked]> wrote:
>>
>>
>> On 30/06/2022 11.37, Magnus Karlsson wrote:
>> > From: Magnus Karlsson <[email-masked]>
>> >
>> > Remove the AF_XDP samples from samples/bpf as they are dependent on
>> > the AF_XDP support in libbpf. This support has now been removed in the
>> > 1.0 release, so these samples cannot be compiled anymore. Please start
>> > to use libxdp instead. It is backwards compatible with the AF_XDP
>> > support that was offered in libbpf. New samples can be found in the
>> > various xdp-project repositories connected to libxdp and by googling.
>> >
>> > Signed-off-by: Magnus Karlsson <[email-masked]>
>>
>> Will you (or Maciej) be submitting these samples to XDP-tools[1] which
>> is the current home for libxdp or maybe BPF-examples[2] ?
>>
>>   [1] https://github.com/xdp-project/xdp-tools
>>   [2] https://github.com/xdp-project/bpf-examples
>>
>> I know Toke is ready to take over maintaining these, but we will
>> appreciate someone to open a PR with this code...
>>
>> > ---
>> >   MAINTAINERS                     |    2 -
>> >   samples/bpf/Makefile            |    9 -
>> >   samples/bpf/xdpsock.h           |   19 -
>> >   samples/bpf/xdpsock_ctrl_proc.c |  190 ---
>> >   samples/bpf/xdpsock_kern.c      |   24 -
>> >   samples/bpf/xdpsock_user.c      | 2019 -------------------------------
>> >   samples/bpf/xsk_fwd.c           | 1085 -----------------
>>
>> The code in samples/bpf/xsk_fwd.c is interesting, because it contains a
>> buffer memory manager, something I've seen people struggle with getting
>> right and performant (at the same time).
>
> I can push xsk_fwd to BPF-examples. Though I do think that xdpsock has
> become way too big to serve as a sample. It slowly turned into a catch
> all demonstrating every single feature of AF_XDP. We need a minimal
> example and then likely other samples for other features that should
> be demoed. So I suggest that xdpsock dies here and we start over with
> something minimal and use xsk_fwd for the forwarding and mempool
> example.
>
> Toke, I think you told me at Recipes in Paris that someone from RedHat
> was working on an example. Did I remember correctly?

I think I was probably referring to
https://github.com/xdp-project/xdp-tools/pull/158 ? Which has sadly
stalled :(

-Toke